/*
 * Created on Jul 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;
import java.util.*;
import javax.vecmath.Matrix3d;
import javax.vecmath.Point3d;
import javax.vecmath.SingularMatrixException;
import javax.vecmath.Tuple3d;
import javax.vecmath.Vector2d;
import javax.vecmath.Vector3d;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Correspondence {
	static void warp(Mesh reference, List targetMarkers){
		if(reference.markers.size() != targetMarkers.size())
			throw new RuntimeException("Target and reference have different number of markers");
		Vector3d diff = new Vector3d();
		Vector3d numerator = new Vector3d();
		Vector3d translation = new Vector3d(.3, .3, 0);
		for(int i = 0; i < reference.vertices.size(); i++){
			Vertex refVertex = (Vertex)reference.vertices.get(i); 
			
			int refIndex = reference.markers.indexOf(refVertex);
			if(refIndex >= 0){
				//targetPos = ((Vertex)target.markers.get(refIndex)).pos; 
			}
			else{
				Vector3d targetPos = new Vector3d(0, 0, 0);
				double normalization = 0;
				for(int j = 0; j < reference.markers.size(); j++){
					Vertex refMarker = (Vertex)reference.markers.get(j);
					Vertex targetMarker = (Vertex)targetMarkers.get(j);
					diff.sub(refVertex.pos, refMarker.pos);
					numerator.add(targetMarker.pos, diff);
					/*
					if(refMarker.pos.x == targetMarker.pos.x)
						System.out.println("PROBLEM");
						*/
					double weight = 1 / diff.lengthSquared();
					targetPos.scaleAdd(weight, numerator, targetPos);
					normalization += weight;
					
				}
				targetPos.scale(1 / normalization);			
				refVertex.pos.set(targetPos);
			}
		}		
		for(int j = 0; j < reference.markers.size(); j++){
			Vertex refMarker = (Vertex)reference.markers.get(j);
			Vertex targetMarker = (Vertex)targetMarkers.get(j);
			refMarker.pos = targetMarker.pos;
		}
		
		for(int i = 0; i < reference.faces.size(); i++){
			Face f = (Face)reference.faces.get(i);
			f.setProperties(reference.vertices, null);
		}
		reference.computeNormals();
	}	
	
	static Vector3d project(Vector3d from, Vector3d dir, Mesh target){
		Vector3d diff = new Vector3d();
		Vector3d intersection = new Vector3d(from);
		double smallestDist = Double.POSITIVE_INFINITY;
		boolean foundIntersection = false;
		for(int j = 0; j < target.faces.size(); j++){
			Face targetFace = (Face)target.faces.get(j);				
			Vertex v0 = (Vertex)target.vertices.get(targetFace.vertices[0]);
			/*
			diff.sub(v0.pos, from);
			//System.out.println(diff.length());
			if(diff.lengthSquared() > .01)
				continue;
			*/
			
			
			Vertex v1 = (Vertex)target.vertices.get(targetFace.vertices[1]);
			Vertex v2 = (Vertex)target.vertices.get(targetFace.vertices[2]);
			
			Vector3d intersect = triangleRayIntersect(v0.pos, v1.pos, v2.pos, from, dir);
			if(intersect.y >= 0 && intersect.z >= 0 && intersect.y + intersect.z <= 1){
//				System.out.println(intersect.x);				
				if(Math.abs(intersect.x) < smallestDist){
					intersection.scaleAdd(intersect.x, dir, from);
					smallestDist = Math.abs(intersect.x);
					foundIntersection = true;
				}
			}
		}					
		if(foundIntersection)
			return intersection;
		else
			return null;
	}
	
	static void subdivideTriangle(int faceIndex, Mesh reference, Mesh target){
		/*
		System.out.println("Subdividing " + faceIndex);
		System.out.println(this);
		*/
		Face f = (Face)reference.faces.get(faceIndex);
		reference.faces.remove(faceIndex);
		
		Vertex v0 = (Vertex)reference.vertices.get(f.vertices[0]);
		Vertex v1 = (Vertex)reference.vertices.get(f.vertices[1]);
		Vertex v2 = (Vertex)reference.vertices.get(f.vertices[2]);
	
		int vert0 = f.vertices[0];
		int vert1 = f.vertices[1];
		int vert2 = f.vertices[2];
		
		int vert3 = reference.vertices.size();
		int vert4 = reference.vertices.size() + 1;
		int vert5 = reference.vertices.size() + 2;

		Vertex v3 = Vertex.avg(v0, v1);
		Vertex v4 = Vertex.avg(v1, v2);
		Vertex v5 = Vertex.avg(v2, v0);
		
		Vector3d v3pos = project(v3.pos, v3.objNormal, target);
		Vector3d v4pos = project(v4.pos, v4.objNormal, target);
		Vector3d v5pos = project(v5.pos, v5.objNormal, target);
		
		if(v3pos != null) v3.pos.set(v3pos);
		if(v4pos != null) v4.pos.set(v4pos);
		if(v5pos != null) v5.pos.set(v5pos);
			
		reference.vertices.add(v3);
		reference.vertices.add(v4);
		reference.vertices.add(v5);
		
		reference.faces.add(new Face(vert0, vert3, vert5, reference.vertices, null));
		reference.faces.add(new Face(vert3, vert1, vert4, reference.vertices, null));
		reference.faces.add(new Face(vert5, vert3, vert4, reference.vertices, null));
		reference.faces.add(new Face(vert5, vert4, vert2, reference.vertices, null));
	}

	
	static void refineProject(Mesh reference, Mesh target){
		int numFaces = reference.faces.size();
		for(int i = 0; i < numFaces; i++){
			if(i % 500 == 0)
				System.out.println("  refining face " + i + " / " + numFaces);
			subdivideTriangle(0, reference, target);			
		}
	}
	
	static Vector3d getProjectionDir(Vertex refVertex, Mesh reference, Mesh target){
		if(reference.markers.size() != target.markers.size())
			throw new RuntimeException("Target and reference have different number of markers");
		Vector3d dir = new Vector3d(), diff = new Vector3d();
		Vector3d numerator = new Vector3d();
		Vector3d translation = new Vector3d(.3, .3, 0);
		
		int refIndex = reference.markers.indexOf(refVertex);
		if(refIndex >= 0){			
			Vector3d targetPos = ((Vertex)target.markers.get(refIndex)).pos;
			dir.sub(targetPos, refVertex.pos);
			dir.normalize();
			return dir;
		}
		else{
			double normalization = 0;
			for(int j = 0; j < reference.markers.size(); j++){
				Vertex refMarker = (Vertex)reference.markers.get(j);
				Vertex targetMarker = (Vertex)target.markers.get(j);
				dir.sub(targetMarker.pos, refMarker.pos);
				diff.sub(refVertex.pos, refMarker.pos);
				double weight = 1 / diff.lengthSquared();
				numerator.scaleAdd(weight, dir, numerator);
				normalization += weight;				
			}
			numerator.normalize();			
			return numerator;
		}
	}		

	static Vector3d getProjectionDir2(Vertex refVertex, Mesh reference, Mesh target){
		if(reference.markers.size() != target.markers.size())
			throw new RuntimeException("Target and reference have different number of markers");
		Vector3d diff = new Vector3d();
		Vector3d numerator = new Vector3d();
		
		int refIndex = reference.markers.indexOf(refVertex);
		Vector3d targetPos = new Vector3d(0, 0, 0);
		if(refIndex >= 0){
			targetPos.set(((Vertex)target.markers.get(refIndex)).pos); 
		}
		else{
			double normalization = 0;
			for(int j = 0; j < reference.markers.size(); j++){
				Vertex refMarker = (Vertex)reference.markers.get(j);
				Vertex targetMarker = (Vertex)target.markers.get(j);
				diff.sub(refVertex.pos, refMarker.pos);
				numerator.add(targetMarker.pos, diff);
				double weight = 1 / diff.lengthSquared();
				targetPos.scaleAdd(weight, numerator, targetPos);
				normalization += weight;
				
			}
			targetPos.scale(1 / normalization);			
		}
		targetPos.sub(refVertex.pos);
		return targetPos;
	}		
	
	static void findProjectionDir(Mesh reference, Mesh target){
		for(int i = 0; i < reference.vertices.size(); i++){
			Vertex refVertex = (Vertex)reference.vertices.get(i);
			refVertex.color = getProjectionDir(refVertex, reference, target);
		}				
	}
	
	static void project(Mesh reference, Mesh target){
		
		//Vector3d projDir = new Vector3d(0, .4, -1);
		Vector3d diff = new Vector3d();
		int foundCounter = 0;
		/*
		for(int i = 0; i < reference.vertices.size(); i++){
			Vertex refVertex = (Vertex)reference.vertices.get(i);
			refVertex.color = getProjectionDir2(refVertex, reference, target);
		}*/
		
		for(int i = 0; i < reference.vertices.size(); i++){
			if(i % 500 == 0)
				System.out.println("  ref vertex: " + i + " / " + reference.vertices.size());
			Vertex refVertex = (Vertex)reference.vertices.get(i);
			//Vector3d projDir = getProjectionDir2(refVertex, reference, target);
			//Vector3d projDir = refVertex.color;
			Vector3d projDir = new Vector3d(0, 0, -1);
			//Vector3d projDir = refVertex.objNormal;
			//System.out.println(projDir);
			Vector3d intersection = project(refVertex.pos, projDir, target);
			if(intersection != null){
				foundCounter++;
				refVertex.pos.set(intersection);
			}
			else{
				System.out.println("Projection of vertex not found: " + refVertex.index);
				refVertex.markedForDeletion = true;
			}
		}
		System.out.println("  found intersections for " + foundCounter + " / " + reference.vertices.size() + " vertices, removing extra verts");
		if(foundCounter != reference.vertices.size())
			throw new RuntimeException();
		reference.deleteMarkedVertices();
		System.out.println("  updating properties...");
		for(int i = 0; i < reference.faces.size(); i++){
			Face f = (Face)reference.faces.get(i);
			f.setProperties(reference.vertices, null);
		}
		reference.computeNormals();
		reference.createAdjacency();
		System.out.println("  done");
	}
		
	
	
	static Matrix3d intersect_transform = new Matrix3d();
	static Vector3d intersect_rhs = new Vector3d();
	
	/**
	 * 
	 * @param v0 triangle vertices
	 * @param v1
	 * @param v2
	 * @param o origin of ray
	 * @param d direction of ray
	 * @return x contains the t, parameter till ray hits. y and z contain baryocentric coordinates for v1 and v2
	 */
	static Vector3d triangleRayIntersect(Vector3d v0, Vector3d v1, Vector3d v2, Tuple3d o, Vector3d d){
		/*
		Matrix3d transform = new Matrix3d(-d.x, v1.x - v0.x, v2.x - v0.x, 
										  -d.y, v1.y - v0.y, v2.y - v0.y,
										  -d.z, v1.z - v0.z, v2.z - v0.z);
		*/
		intersect_transform.m00 = -d.x;
		intersect_transform.m01 = v1.x - v0.x;
		intersect_transform.m02 = v2.x - v0.x;
		
		intersect_transform.m10 = -d.y;
		intersect_transform.m11 = v1.y - v0.y;
		intersect_transform.m12 = v2.y - v0.y;

		intersect_transform.m20 = -d.z;
		intersect_transform.m21 = v1.z - v0.z;
		intersect_transform.m22 = v2.z - v0.z;

		try{
			intersect_transform.invert();
		}
		catch(SingularMatrixException e){
			e.printStackTrace();
			intersect_rhs.set(Double.POSITIVE_INFINITY, Double.POSITIVE_INFINITY, Double.POSITIVE_INFINITY);
			
		}
		//Vector3d rhs = new Vector3d(o.x - v0.x, o.y - v0.y, o.z - v0.z);
		intersect_rhs.set(o.x - v0.x, o.y - v0.y, o.z - v0.z);
		intersect_transform.transform(intersect_rhs);
		return intersect_rhs;
	}
/*
	Vector3d e1 = new Vector3d(), e2 = new Vector3d();
	Vector3d faceNormal = new Vector3d(), projectedPoint = new Vector3d();

	Vector3d triangleIntersect(Vector3d v0, Vector3d v1, Vector3d v2, Point3d lineOrigin, Vector3d lineDir){						
		e1.sub(v1, v0);
		e2.sub(v2, v0);
		
		faceNormal.cross(e1, e2);
		faceNormal.normalize();
		
		projectedPoint.sub(point, v0);
		distToTriangle_projectedPoint.scaleAdd(-distToTriangle_projectedPoint.dot(distToTriangle_faceNormal), distToTriangle_faceNormal, distToTriangle_projectedPoint);
		
		
		double detInv = 1.0/(e1.lengthSquared()*e2.lengthSquared() - e1.dot(e2) * e1.dot(e2));
	
		projectedPointcoords.x = e2.lengthSquared() * projectedPoint.dot(e1) - e1.dot(e2) * projectedPoint.dot(e2);
		projectedPointcoords.y = e1.lengthSquared() * projectedPoint.dot(e2) - e1.dot(e2) * projectedPoint.dot(e1);

		distToTriangle_projectedPointcoords.scale(detInv);
		//System.out.println(coords);
		double d = -v0.dot(distToTriangle_faceNormal);
		double dist = point.dot(distToTriangle_faceNormal) + d;
		if(Math.abs(dist) > Math.abs(minDist)){
			return Double.POSITIVE_INFINITY;
		}
		if(distToTriangle_projectedPointcoords.x >= 0 && distToTriangle_projectedPointcoords.y >= 0 && (distToTriangle_projectedPointcoords.x + distToTriangle_projectedPointcoords.y <= 1)){ //in triangle
			//System.out.println("Inside triangle");						 			
			//System.out.println(dist); 		
			if(distToTriangle_faceNormal.dot(mesh.normals[face]) > 0)
				return dist;
			else
				return -dist;		
		}		
	
	}
	*/
	
	/*
	Vector3d distToTriangle_e1 = new Vector3d(), distToTriangle_e2 = new Vector3d();
	Vector3d distToTriangle_faceNormal = new Vector3d(), distToTriangle_projectedPoint = new Vector3d();
	Vector2d distToTriangle_projectedPointcoords = new Vector2d();
	Vector3d distToTriangle_otherDir = new Vector3d();
	Vector3d distToTriangle_pointToIntersection = new Vector3d();
	
	double distToTriangle(Vector3d point, Face f, double minDist){ 
		
		Vector3d v0 = mesh.vertices[mesh.faces[face][0]];
		Vector3d v1 = mesh.vertices[mesh.faces[face][1]];
		Vector3d v2 = mesh.vertices[mesh.faces[face][2]];
		
		distToTriangle_e1.sub(v1, v0);
		distToTriangle_e2.sub(v2, v0);
		
		distToTriangle_faceNormal.cross(distToTriangle_e1, distToTriangle_e2);
		distToTriangle_faceNormal.normalize();
		
		distToTriangle_projectedPoint.sub(point, v0);
		distToTriangle_projectedPoint.scaleAdd(-distToTriangle_projectedPoint.dot(distToTriangle_faceNormal), distToTriangle_faceNormal, distToTriangle_projectedPoint);
		
		double detInv = 1.0/(distToTriangle_e1.lengthSquared()*distToTriangle_e2.lengthSquared() - distToTriangle_e1.dot(distToTriangle_e2)*distToTriangle_e1.dot(distToTriangle_e2));
	
		distToTriangle_projectedPointcoords.x = distToTriangle_e2.lengthSquared() * distToTriangle_projectedPoint.dot(distToTriangle_e1) - distToTriangle_e1.dot(distToTriangle_e2) * distToTriangle_projectedPoint.dot(distToTriangle_e2);
		distToTriangle_projectedPointcoords.y = distToTriangle_e1.lengthSquared() * distToTriangle_projectedPoint.dot(distToTriangle_e2) - distToTriangle_e1.dot(distToTriangle_e2) * distToTriangle_projectedPoint.dot(distToTriangle_e1);
		distToTriangle_projectedPointcoords.scale(detInv);
		//System.out.println(coords);
		double d = -v0.dot(distToTriangle_faceNormal);
		double dist = point.dot(distToTriangle_faceNormal) + d;
		if(Math.abs(dist) > Math.abs(minDist)){
			return Double.POSITIVE_INFINITY;
		}
		if(distToTriangle_projectedPointcoords.x >= 0 && distToTriangle_projectedPointcoords.y >= 0 && (distToTriangle_projectedPointcoords.x + distToTriangle_projectedPointcoords.y <= 1)){ //in triangle
			//System.out.println("Inside triangle");						 			
			//System.out.println(dist); 		
			if(distToTriangle_faceNormal.dot(mesh.normals[face]) > 0)
				return dist;
			else
				return -dist;		
		}
		else{
			distToTriangle_projectedPointcoords.x = distToTriangle_projectedPoint.dot(distToTriangle_e1) / distToTriangle_e1.lengthSquared();
			distToTriangle_otherDir.cross(distToTriangle_faceNormal, distToTriangle_e1);
			distToTriangle_projectedPointcoords.y = distToTriangle_projectedPoint.dot(distToTriangle_otherDir);
			if(distToTriangle_projectedPointcoords.x >= 0 && distToTriangle_projectedPointcoords.x <= 1 && distToTriangle_projectedPointcoords.y <= 0){
				//System.out.println("edge 1");
				Vector3d PmB = new Vector3d();
				PmB.sub(point, v0);
				double t0 = distToTriangle_e1.dot(PmB)/distToTriangle_e1.lengthSquared();
				distToTriangle_pointToIntersection.scaleAdd(t0, distToTriangle_e1, v0);
				distToTriangle_pointToIntersection.sub(point, distToTriangle_pointToIntersection);
				int vertex1_index = mesh.faces[face][0];
				int vertex2_index = mesh.faces[face][1];
				if(distToTriangle_pointToIntersection.dot(edgeWeightedNormals[vertex1_index][vertex2_index]) > 0)
					return distToTriangle_pointToIntersection.length();
				else
					return -distToTriangle_pointToIntersection.length();				 
			}
			else{
				distToTriangle_projectedPointcoords.x = distToTriangle_projectedPoint.dot(distToTriangle_e2) / distToTriangle_e2.lengthSquared();
				distToTriangle_otherDir.cross(distToTriangle_e2, distToTriangle_faceNormal);
				distToTriangle_projectedPointcoords.y = distToTriangle_projectedPoint.dot(distToTriangle_otherDir);
				if(distToTriangle_projectedPointcoords.x >= 0 && distToTriangle_projectedPointcoords.x <= 1 && distToTriangle_projectedPointcoords.y <= 0){
					//System.out.println("edge 2");
					Vector3d PmB = new Vector3d();
					PmB.sub(point, v0);
					double t0 = distToTriangle_e2.dot(PmB)/distToTriangle_e2.lengthSquared();
					distToTriangle_pointToIntersection.scaleAdd(t0, distToTriangle_e2, v0);
					distToTriangle_pointToIntersection.sub(point, distToTriangle_pointToIntersection);
					int vertex1_index = mesh.faces[face][0];
					int vertex2_index = mesh.faces[face][2];
					if(distToTriangle_pointToIntersection.dot(edgeWeightedNormals[vertex1_index][vertex2_index]) > 0)
						return distToTriangle_pointToIntersection.length();
					else
						return -distToTriangle_pointToIntersection.length();				 
				}
				else{
					distToTriangle_projectedPoint.sub(distToTriangle_e1);
					Vector3d e3 = new Vector3d();
					e3.sub(v2, v1);
					distToTriangle_projectedPointcoords.x =distToTriangle_projectedPoint.dot(e3) / e3.lengthSquared();
					distToTriangle_otherDir.cross(distToTriangle_faceNormal, e3);
					distToTriangle_projectedPointcoords.y = distToTriangle_projectedPoint.dot(distToTriangle_otherDir);
					if(distToTriangle_projectedPointcoords.x >= 0 && distToTriangle_projectedPointcoords.x <= 1 && distToTriangle_projectedPointcoords.y <= 0){
						//System.out.println("edge 3");
						Vector3d PmB = new Vector3d();
						PmB.sub(point, v1);
						double t0 = e3.dot(PmB)/e3.lengthSquared();
						distToTriangle_pointToIntersection.scaleAdd(t0, e3, v1);
						distToTriangle_pointToIntersection.sub(point, distToTriangle_pointToIntersection);
						int vertex1_index = mesh.faces[face][1];
						int vertex2_index = mesh.faces[face][2];
						if(distToTriangle_pointToIntersection.dot(edgeWeightedNormals[vertex1_index][vertex2_index]) > 0)
							return distToTriangle_pointToIntersection.length();
						else
							return -distToTriangle_pointToIntersection.length();				 
					}
					else{
						distToTriangle_pointToIntersection.sub(point, v0);
						double dist0 = distToTriangle_pointToIntersection.lengthSquared();
						distToTriangle_pointToIntersection.sub(point, v1);
						double dist1 = distToTriangle_pointToIntersection.lengthSquared();
						distToTriangle_pointToIntersection.sub(point, v2);
						double dist2 = distToTriangle_pointToIntersection.lengthSquared();
						if(dist0 < dist1 && dist0 < dist2){
							//System.out.println("vertex 0");
							int vertexIndex = mesh.faces[face][0];
							distToTriangle_pointToIntersection.sub(point, v0);
							if(distToTriangle_pointToIntersection.dot(vertexWeightedNormals[vertexIndex]) > 0)							
								return Math.sqrt(dist0);
							else
								return -Math.sqrt(dist0);
						}
						else if(dist1 < dist2){
							//System.out.println("vertex 1");
							int vertexIndex = mesh.faces[face][1];
							distToTriangle_pointToIntersection.sub(point, v1);
							if(distToTriangle_pointToIntersection.dot(vertexWeightedNormals[vertexIndex]) > 0)							
								return Math.sqrt(dist1);
							else
								return -Math.sqrt(dist1);
						}
						else{
							//System.out.println("vertex 2");
							int vertexIndex = mesh.faces[face][2];
							distToTriangle_pointToIntersection.sub(point, v2);
							if(distToTriangle_pointToIntersection.dot(vertexWeightedNormals[vertexIndex]) > 0)							
								return Math.sqrt(dist2);
							else
								return -Math.sqrt(dist2);
						}
	
					}
				}
			}
		}
	}
	*/
}
