/*
 * Created on Jun 17, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;
import java.awt.*;
import java.awt.event.*; 
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;
import java.util.List;

import javax.vecmath.Point3d;
import javax.vecmath.Vector2d;
import javax.vecmath.Vector3d;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLU;
import net.java.games.jogl.util.GLUT;
import javax.imageio.*;

import Jama.*;
/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ImageLoader extends ArcBall implements KeyListener, MouseListener{

	Image[] images;
	float mins[]; //0 -> bands.length, [bands.length] for image
	float maxes[];

	int imageIndex = 0;
	
	SimoncelliPyramid pyramid;
	
	boolean drawCDFs = false;
	
	static int numStatisticTiles = 16;
	static final int numBins = 256;
	
	boolean drawWrinkles = true;
	List wrinkles;
	Wrinkle selectedWrinkle = null;
	
	List wrinklePatches;
	boolean drawWrinklePatches = false;
	
	boolean drawWrinkleClusters = true;
	int chosenCluster = 0;
	WrinkleCluster wrinkleClusters[];
	
	Image sourceImage;
	Image curvatureImage;
	Image threshCurvatureBin;
	Image thinnedCurvatureBin;
	
	
	int startX = 0, startY = 0, endX = 1024, endY = 1024;

	
	static int imageWidth = -1;
		
	static final int SHOW_IMAGES = 0;
	static final int GET_WRINKLES = 1;
	static final int SYNTHESIZE = 2;
	static final int GET_WRINKLES2 = 3;
	static final int INTERPOLATE = 4;
	static final int CHECK_STATS = 5;
	
	public ImageLoader(String files[], int runType){
		System.out.println("Opening image loader, with command: " + runType);
		imageWidth = endX - startX;
		if(runType == SHOW_IMAGES)
			setupShowImages(files);
		else if(runType == GET_WRINKLES)
			setupGetWrinkles(files);
		else if(runType == GET_WRINKLES2)
			setupGetWrinkles2(files);
		else if(runType == SYNTHESIZE)
			setupSynthesis(files);
		else if(runType == INTERPOLATE)
			setupInterpolation(files);
		else if(runType == CHECK_STATS)
			setupCheckStats(files);
		/*
		Image testImage = new Image(6, 6);
	    testImage.data[3][3] = 2;
	    List pixels = new ArrayList();
	    pixels.add(new Pixel(3, 3));	   
		Wrinkle testWrinkle = new Wrinkle(pixels, testImage);
		testWrinkle.avgWidth = 2.001f;
		testImage.addWrinkleDisplacement(testWrinkle);
		System.out.println(testImage);
		*/
		/*
		Image testImage = new Image(10, 10);
	    for(int i = 0; i < testImage.width; i++)
	    	for(int j = 0; j < testImage.height; j++)
	    		if(j >= 3 && j <= 6)
	    			testImage.data[i][j] = 1;
	    		
	    System.out.println(testImage.getLength(new Pixel(4, 3), new Vector2d(0, -2)));
	    */
	    
		/*//test matrix
		double[][] vals = {{2, 0},{0, 1}};
	    Matrix A = new Matrix(vals);
	    A.print(4, 2);
		EigenvalueDecomposition eig = A.eig();
		double eigValues[] = eig.getRealEigenvalues();
		System.out.println(eigValues[0] + ". " + eigValues[1]);
		eig.getV().print(4, 2);
	    */
		/*
		int numAngles = 16;
		for(int i = 0; i < numAngles; i++){
			double angle = i * Math.PI * 2 / numAngles + Math.PI / 16;
			double degrees = angle * 180 / Math.PI;
			System.out.println(degrees + ": " + Image.nextPixel(1, 1, new Vector2d(2 * Math.cos(angle), 2 * Math.sin(angle))));
		}
		*/
		
		remove(canvas);
		ScrollPane scroller = new ScrollPane();
		scroller.add(canvas);
		add(scroller);
		
		canvas.addKeyListener(this);
		canvas.addMouseMotionListener(this);
		/*
		images = new Image[files.length];
		for(int i = 0; i < images.length; i++){
			images[i] = new Image(files[i]);
			images[i].createPyramid();
		}*/
		
		/*
		pyramid = new SimoncelliPyramid(4);
		pyramid.expand(images[0], 4, new CircularEdgeHandler());
		pyramid.collapse(new CircularEdgeHandler());
		*/
		//Image textureImage = new Image(256, 256, "dog_tooth_material.jpg");
		
		/*
		Image textureImage = new Image(512, 512, new String[]{				
				"Desert_Erosion.jpg", "fineripple.gif", "greenmaze.gif", "dog_tooth_material.jpg"});
		*/
		//Image textureImage = images[0];
		
		//testStatistics();
		//interpolate(files);
		
		Image textureImage = new Image(files[0]);
		
		//Image textureImage = new Image(400, 400, "ibm.input.3.jpg");
		
		//textureImage = textureImage.downSample().downSample();
		/*
		textureImage = new Image(300, 100);
		float centerY = textureImage.height/ 2; 
		for(int i = 0; i < textureImage.width; i++)
			for(int j = 0; j < textureImage.height; j++)
				textureImage.data[i][j] = (j - centerY) * (j - centerY);
		*/
		
		/*
		Image wrinkleImage = new Image(files[1]);		
		images = new Image[3];
		images[0] = textureImage;
		images[1] = wrinkleImage;
		images[2] = new Image(textureImage);
		images[2].add(wrinkleImage);
		*/
		
		//textureImage = textureImage.subImage(512, 1024, 512, 1024);
		
		

		
		/*
		
		images = new Image[3]; 
		Image wrinkleImage = new Image(files[2]);
		wrinkleImage = wrinkleImage.subImage(startX, endX, startY, endY);
		
		images[0] = new Image(files[0]);
		images[0] = images[0].subImage(startX, endX, startY, endY);

		numStatisticTiles = images[0].width / 64;
		System.out.println("Number of statistics tiles: " + numStatisticTiles + ", size: " + images[0].width / numStatisticTiles); 

		images[1] = new Image(files[1]);
		images[1] = images[1].subImage(startX, endX, startY, endY);
		images[1].add(wrinkleImage);
		Image withWrinkles = new Image(images[1]);
		//images[1].addNoise();
		
		
		//images[2] = new Image(images[1]);
		//images[2].add(wrinkleImage);
		
		//images[2].matchStatisticsOf(images[0], 4, 4);
		
		LocalICDF localStats[] = new LocalICDF[3];
		LocalICDF im0Stats = new LocalICDF(images[0], 4, numStatisticTiles);
		for(int i = 0; i < localStats.length; i++)
			localStats[i] = new LocalICDF(im0Stats);
		LocalICDF statsToMatch = LocalICDF.avg(localStats);
		
		//images[1].matchStatisticsOf(images[0], 4, 4);
		images[1].matchStatisticsOf(statsToMatch, 4, 4);
		images[2] = new Image(images[1]);
		//images[2].add(wrinkleImage);
		
		//images[0] = withWrinkles;

		for(int i = 0; i < images.length; i++){
			images[i].createDrawnImage();
		}
		*/
		
		/*
		images[3] = new Image(images[2]);
		images[3].add(wrinkleImage);
		images[3].add(wrinkleImage);
		images[3].add(wrinkleImage);
		images[3].matchStatisticsOf(images[0], 3);
		*/

		/*
		images = new Image[3]; 
		//Image wrinkleImage = new Image(files[2]);		
		
		images[0] = new Image(files[0]);
		images[1] = new Image(files[1]);
		images[2] = new Image(images[1]);
		
		images[1].matchStatisticsOf(images[0], 3);
		//images[1].add(wrinkleImage);
		
		//images[1].addNoise();
		
		
		for(int i = 0; i < images.length; i++){
			images[i].createSteerablePyramid(4, 3);
			//images[i].createDrawnImage(true);
			//images[i].pyramid.collapse(new CircularEdgeHandler());
			//images[i].createHistograms(true, 256);
		}				
		
		mins = new float[images[0].pyramid.bands.length + 1];
		maxes = new float[images[0].pyramid.bands.length + 1];
		for(int i = 0; i < mins.length; i++){
			mins[i] = Float.POSITIVE_INFINITY;
			maxes[i] = Float.NEGATIVE_INFINITY;
			for(int j = 0; j < images.length; j++){
				Image image = null;
				if(i < images[j].pyramid.bands.length)
					image = images[j].pyramid.bands[i];
				else
					image = images[j];
				
				mins[i] = Math.min(mins[i], image.min());
				maxes[i] = Math.max(maxes[i], image.max());
			}
		}
		for(int i = 0; i < images.length; i++){
			images[i].createDrawnImage(mins, maxes);
		}
		*/

		
		
		/*
		incline.PDF = new Histogram(256, incline);
		incline.CDF = incline.PDF.getCDF();
		incline.ICDF = new InverseCDF(incline.CDF, 256);
		System.out.println(incline.PDF);*/
		//System.out.println(ICDF);
		
		/*
		for(int i = 0; i < pyramid.filters.length; i++)
			addImage(pyramid.filters[i]);
		*/			
		
	}		
	
	void setupSynthesis(String files[]){
		/*
		 * 0: target image
		 * 1: original image
		 * 2: original image with wrinkles
		 * 3: synthesized after wrinkles
		 * 4: just synthesized 
		 */
		
		images = new Image[5]; 
		Image wrinkleImage = new Image(files[2]);
		wrinkleImage = wrinkleImage.subImage(startX, endX, startY, endY);
		
		images[0] = new Image(files[0]);
		images[0] = images[0].subImage(startX, endX, startY, endY);

		numStatisticTiles = images[0].width / 64;
		System.out.println("Number of statistics tiles: " + numStatisticTiles + ", size: " + images[0].width / numStatisticTiles); 

		images[1] = new Image(files[1]);
		images[1] = images[1].subImage(startX, endX, startY, endY);
						
		images[2] = new Image(images[1]);
		images[2].add(wrinkleImage);		

		images[3] = new Image(images[2]);		
		images[4] = new Image(images[1]);		

		images[3].matchStatisticsOf(images[0], 4, 4);		
		//images[4].matchStatisticsOf(images[0], 4, 4);		

		/*
		for(int i = 0; i < images.length; i++){
			images[i].createDrawnImage();
		}*/
		

	}
	
	void setupShowImages(String files[]){
		
		List imageList = new ArrayList();
		for(int i = 0; i < files.length; i++){
			File imageFile = new File(files[i]);
			if(imageFile.isDirectory()){
				File subFiles[] = imageFile.listFiles();
				for(int j = 0; j < subFiles.length; j++)
					imageList.add(new Image(subFiles[j].getAbsolutePath()));
			}
			else
				imageList.add(new Image(files[i]));
		}
		images = new Image[imageList.size()];
		for(int i = 0; i < images.length; i++)
			images[i] = (Image)imageList.get(i);
		
		
		/*
		Image image = new Image(files[0]);
		image.createSteerablePyramid(4, 4);
		images = new Image[image.pyramid.bands.length + 1];
		images[0] = image;
		for(int i = 1; i < images.length; i++)
			images[i] = image.pyramid.bands[i - 1];
		*/
		
		//images[0] = Image.perlinNoise(1024, 1024);
	}

	
	void setupGetWrinkles2(String files[]){
		Image textureImage = new Image(files[0]);
		textureImage = textureImage.subImage(512, 1024, 512, 1024);
		
		images = new Image[8];
		sourceImage = textureImage;
		
		images[0] = sourceImage;//.subImage(512, 1024, 512, 1024);
		curvatureImage = textureImage.edgeDetect(-0.000008f);
		images[1] = curvatureImage;
		threshCurvatureBin = textureImage.threshCurvatureBin;
		images[2] = threshCurvatureBin;
		thinnedCurvatureBin = new Image(threshCurvatureBin);
		thinnedCurvatureBin.suppress(curvatureImage, sourceImage.normalDirections);
		images[3] = thinnedCurvatureBin;
		images[4] = new Image(textureImage.height, textureImage.width);
		
		//wrinkles = Image.removeWrinkles(threshCurvatureBin, thinnedCurvatureBin, sourceImage, sourceImage.principleDirections, sourceImage.normalDirections);
		wrinkles = Wrinkle.getWrinkles(sourceImage);
		wrinklePatches = WrinklePatch.getPatches(wrinkles, sourceImage);
		images[4].applyWrinkles(wrinkles);
		images[5] = new Image(sourceImage);
		images[5].subtract(images[4]);

		images[6] = new Image(textureImage.height, textureImage.width);		
		images[6].applyWrinklePatches(wrinklePatches);
		
		//images[7] = ((Wrinkle)wrinkles.get(0)).diffImage;
		//images[7] = sourceImage;
		
		
		images[7] = new Image(sourceImage);
		images[7].subtract(images[6]);
		
		
		//wrinkleClusters = WrinkleModel.getWrinkleClusters(wrinkles);

	}

	void setupGetWrinkles(String files[]){
		Image textureImage = new Image(files[0]);

		images = new Image[6];
		sourceImage = textureImage;
		
		images[0] = textureImage;//.subImage(512, 1024, 512, 1024);
		curvatureImage = textureImage.edgeDetect(-0.000008f);
		images[1] = curvatureImage;
		threshCurvatureBin = textureImage.threshCurvatureBin;
		images[2] = threshCurvatureBin;
		thinnedCurvatureBin = new Image(threshCurvatureBin);
		thinnedCurvatureBin.suppress(curvatureImage, sourceImage.normalDirections);
		images[3] = thinnedCurvatureBin;
		images[4] = new Image(textureImage.height, textureImage.width);
		
		wrinkles = Image.removeWrinkles(threshCurvatureBin, thinnedCurvatureBin, sourceImage, sourceImage.principleDirections, sourceImage.normalDirections);
		images[images.length - 2].applyWrinkles(wrinkles);
		images[images.length - 1] = new Image(sourceImage);
		images[images.length - 1].subtract(images[images.length - 2]);
		
		wrinkleClusters = WrinkleModel.getWrinkleClusters(wrinkles, 50);

	}

	void setupCheckStats(String[] files){
		images = new Image[3];
		images[0] = new Image(files[0]);
		images[1] = new Image(images[0]);
		images[2] = new Image(images[0]);
		//LocalICDF stats1 = new LocalICDF(images[0], 4, numStatisticTiles);
		LocalICDF stats2 = new LocalICDF(files[1]);
		System.out.println("*******************");
		//System.out.println(stats1.equals(stats2));
		System.out.println("*******************");
		//images[1].matchStatisticsOf(stats1, 4, 4);
		images[2].matchStatisticsOf(stats2, 4, 4);
	}
	
	void setupInterpolation(String[] files){
		int numInputs = 3;
		Image[] inputs = new Image[3];
		for(int i = 0; i < inputs.length; i++){
			inputs[i] = new Image(files[i]);
			//inputs[i] = inputs[i].subImage(512, 1024, 512, 1024);
		}
		
		
		images = new Image[numInputs + 4];
		for(int i = 0; i < numInputs; i++)
			images[i] = inputs[i];

		images[numInputs + 1] = Image.avgOf(inputs); 
		//images[numInputs] = new Image(files[3]);
		images[numInputs + 2] = new Image(images[numInputs + 1]);
		//images[numInputs + 1] = new Image(files[3]);

		WrinkleStats wrinkleStats = new WrinkleStats(inputs);
		wrinkleClusters = wrinkleStats.wrinkleClusters;
		WrinkleVector avgWrinkles = WrinkleVector.avg(inputs);
		System.out.println(avgWrinkles);
		
		/*
		//wrinkle image:
		images[numInputs] = WrinkleStats.adjustImage(images[numInputs + 2], avgWrinkles, wrinkleClusters);
		
		images[numInputs + 3] = new Image(images[numInputs + 2]);
		

		numStatisticTiles = images[0].width / 64;
		
		
		
		LocalICDF stats[] = new LocalICDF[numInputs];
		for(int i = 0; i < stats.length; i++)
			stats[i] = new LocalICDF(inputs[i], 4, numStatisticTiles);
		
		LocalICDF avgStat = LocalICDF.avg(stats);
		images[numInputs + 3].matchStatisticsOf(avgStat, 4, 4);		
		*/
		
		for(int i = 0; i < images.length; i++){
			if(images[i] != null)
				images[i].createDrawnImage();
		}

	}
	
	void testStatistics(){
		Image inc1 = Image.incline(50, 0, 1);
		Image inc2 = Image.incline(50, 2, 3);
		Histogram hist1 = new Histogram(inc1); 
		Histogram hist2 = new Histogram(inc2);
		
		InverseCDF ICDF1 = new InverseCDF(hist1.getCDF());
		InverseCDF ICDF2 = new InverseCDF(hist2.getCDF());
		
		InverseCDF avg = InverseCDF.avg(new InverseCDF[]{ICDF1, ICDF2});

		System.out.println("ICDF1: " + ICDF1);
		System.out.println("ICDF2: " + ICDF2);
		System.out.println("avg: " + avg);
	}
	
	int[] drawnLocation = new int[2];

	
	boolean initialized = false;
    public void draw(GL gl, GLU glu, GLUT glut)
    {    	    	    			
    	if(!initialized){
	    	//this.setSize(1200, 600);
	    	//Insets insets = getInsets();
	    	//canvas.setSize(3000, getHeight() - (insets.top + insets.bottom));
			//canvas.setSize(2600, 1300);
			initialized = true;
		}
		Image image = images[imageIndex];
		
    	try{		
    		gl.glClearColor(0, 0, 0, 1);
    		gl.glClear (GL.GL_COLOR_BUFFER_BIT);
	        gl.glClear (GL.GL_DEPTH_BUFFER_BIT);
	        
	            		
    		gl.glClear (GL.GL_COLOR_BUFFER_BIT);
	        gl.glClear (GL.GL_DEPTH_BUFFER_BIT);
	        gl.glMatrixMode( GL.GL_PROJECTION );  
            
	        gl.glPushMatrix();
            gl.glLoadIdentity(); 
            
            //glu.gluOrtho2D( 0.0, 450.0, 0.0, 375.0);
            gl.glOrtho(0, canvas.getWidth(), 0, canvas.getHeight(), -30, 30);    
            
            gl.glMatrixMode(GL.GL_MODELVIEW);
        	gl.glPushMatrix();
        	gl.glLoadIdentity();
            
        	gl.glDisable(GL.GL_LIGHTING);        	
        	
        	if(pyramid != null)
        		pyramid.draw(gl, 0, 0, true);
        	else{
        		if(image == null)
            		throw new RuntimeException("Null image!");
        		//image.drawPyramid(gl, 0, 0);
        		image.draw(gl, 0, 0, drawCDFs);
        		//image.pyramid.lowPass().drawImage(gl, 0, 0);
        		//System.out.println(image.pyramid.lowPass());
        	}
        	
        	
        	if(drawnLocation[0] >= 0 && drawnLocation[0] < image.width 
        			&& drawnLocation[1] >= 0 && drawnLocation[1] < image.height && images[0].principleDirections != null){
	        	int x = drawnLocation[0];
	        	int y = drawnLocation[1];
	        	//System.out.println(x + ", " + y);
        		Vector2d dir = images[0].principleDirections[x][y];
        		if(dir != null){        			
	        		//System.out.println(dir);
		        	float size = 10;
		        	gl.glColor3d(1, 0, 0);
		        	gl.glDisable(GL.GL_DEPTH_TEST);
		        	gl.glLineWidth(1);
		        	gl.glBegin(GL.GL_LINES);
		        		        	
		        	gl.glVertex2d(x - size * dir.x, y - size*dir.y);
		        	gl.glVertex2d(x + size * dir.x, y + size*dir.y);
			        gl.glEnd();
        		}
        	}        	
        	
        	gl.glPointSize(1);
        	if(wrinkles != null && drawWrinkles){
        		for(int i = 0; i < wrinkles.size(); i++){
        			Wrinkle wrinkle = (Wrinkle)wrinkles.get(i);
        			wrinkle.draw(gl);        			
        		}

        		if(selectedWrinkle != null){
            		selectedWrinkle.draw(gl, true);
            	}
        	}
        	
        	if(wrinklePatches != null && drawWrinklePatches){
        		for(int i = 0; i < wrinklePatches.size(); i++){
        			WrinklePatch wrinklePatch = (WrinklePatch)wrinklePatches.get(i);
        			wrinklePatch.draw(gl);        			
        		}
        	}

        	if(wrinkleClusters != null && drawWrinkleClusters){
        		for(int i = 0; i < wrinkleClusters.length; i++){
        			if(chosenCluster == i)
        				gl.glLineWidth(3);
        			else
        				gl.glLineWidth(1);
        			wrinkleClusters[i].draw(gl);
        		}
        	}
        	
	        gl.glMatrixMode(GL.GL_PROJECTION);
	        gl.glPopMatrix();
	        
	        gl.glMatrixMode(GL.GL_MODELVIEW);
        	gl.glPopMatrix(); 
        	
        	
        }
    	catch(Exception e){
    		e.printStackTrace();
    	}    	
    }

	
	public static void main(String[] args) {		
		String[] files = new String[args.length - 1];
		for(int i = 0; i < files.length; i++)
			files[i] = args[i+1];
		
		int action = -1;
		if(args[0].equals("show"))
			action = SHOW_IMAGES;
		else if(args[0].equals("wrinkles"))
			action = GET_WRINKLES;
		else if(args[0].equals("wrinkles2"))
			action = GET_WRINKLES2;
		else if(args[0].equals("synthesize"))
			action = SYNTHESIZE;
		else if(args[0].equals("interpolate"))
			action = INTERPOLATE;
		else if(args[0].equals("check_stats"))
			action = CHECK_STATS;
		else
			throw new RuntimeException();
		
		ImageLoader loader = new ImageLoader(files, action);
		loader.pack();
		loader.setVisible(true);
		
	}

	public void addImage(Image image){
		imageIndex = 0;
		Image[] newImages = new Image[images.length + 1];
		for(int i = 0; i < images.length; i++)
			newImages[i + 1] = images[i];
		images = newImages;
		images[0] = image;
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
	 */
	public void keyPressed(KeyEvent arg0) {
		if(arg0.getKeyChar() == ','){
			imageIndex = (imageIndex + images.length - 1) % images.length;
			System.out.println(imageIndex + ": " + images[imageIndex].fileName + 
								", avg: " + images[imageIndex].sum() / images[imageIndex].width / images[imageIndex].height
								+ ", min/max: " + images[imageIndex].min() + " / " + images[imageIndex].max());
		}
		else if(arg0.getKeyChar() == '.'){
			imageIndex = (imageIndex + 1) % images.length;
			System.out.println(imageIndex + ": " + images[imageIndex].fileName + 
					", avg: " + images[imageIndex].sum() / images[imageIndex].width / images[imageIndex].height
					+ ", min/max: " + images[imageIndex].min() + " / " + images[imageIndex].max());
		}
		else if(arg0.getKeyChar() == 'i'){ //interpolate
			Image newImage = new Image(images[0]);
			newImage.interpolate(images[1], .5f);
			newImage.createDrawnImage(true);
			newImage.createPyramid();		
			addImage(newImage);
		}
		else if(arg0.getKeyChar() == 'I'){ 
			Image newImage = Image.incline(4, 0, 1);
			addImage(newImage);			
		}		
		else if(arg0.getKeyChar() == 's'){
			FileDialog fd = new FileDialog(this, "Save image as", FileDialog.SAVE);
			Image image = images[imageIndex];
			if(pyramid != null)
				image = pyramid.collapsedImage;
			fd.setFile(image.fileName);
			fd.show();				
			String fileName = fd.getDirectory() + fd.getFile();
			if(fileName == null)
				return;
			//System.out.println("Selected file: " + fileName);
			image.save(fileName);
			
		}
		else if(arg0.getKeyChar() == 'c'){
			System.out.println("Convolving");
			Image image = images[imageIndex];
			Image filter = new Image(5, 5);
			filter.data[2][2] = 1;
			Image result = new Image(image.width/2, image.height/2);
			Image.convolve(image, filter, result, false, 2, 2);
			//System.out.println(image);
			//System.out.println(result);
			result.createDrawnImage();
			addImage(result);
			
		}
		else if(arg0.getKeyChar() == 'u'){
			System.out.println("Upsampling");
			Image image = images[imageIndex];
			Image result = new Image(image.width * 2, image.height * 2);
			Image.upSample(image, result);
			result.createDrawnImage();
			addImage(result);
			//System.out.println(image);
			//System.out.println(result);
		}
		else if(arg0.getKeyChar() == 'C'){
			drawCDFs = !drawCDFs;
			System.out.println("Draw CDFs: " + drawCDFs);
		}
		else if(arg0.getKeyChar() == 'w'){
			drawWrinkles = !drawWrinkles;
			System.out.println("Draw wrinkles: " + drawWrinkles);
		}
		else if(arg0.getKeyChar() == 'p'){
			drawWrinklePatches = !drawWrinklePatches;
			System.out.println("Draw wrinkle patches: " + drawWrinklePatches);
		}
		else if(arg0.getKeyChar() == 'W'){
			drawWrinkleClusters = !drawWrinkleClusters;
			System.out.println("Draw wrinkle clusters: " + drawWrinkleClusters);
		}
		else if(arg0.getKeyChar() == 'S'){
			images[imageIndex].suppress(images[1], images[0].normalDirections);
		}
		else if(arg0.getKeyChar() == ' '){
			images[imageIndex].drawScale = (images[imageIndex].drawScale + 1) % 4;
			images[imageIndex].createDrawnImage();
			System.out.println("Image: " + imageIndex + ", draw scale: " + images[imageIndex].drawScale);
		}
		else if(arg0.getKeyChar() == '='){
			chosenCluster = (chosenCluster + 1) % wrinkleClusters.length;
			System.out.println("Chosen cluster: " + chosenCluster);
		}
		else if(arg0.getKeyChar() == '-'){
			chosenCluster = (chosenCluster + wrinkleClusters.length - 1) % wrinkleClusters.length; 
			System.out.println("Chosen cluster: " + chosenCluster);
		}
		canvas.repaint();
	}

	void chooseStructure(int x, int y){
		Image bitmap = images[imageIndex];
		System.out.println(x + ", " + y + ": " + (bitmap.data[x][y] > 0));
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
	 */
	public void keyReleased(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
	 */
	public void keyTyped(KeyEvent arg0) {	
	}

	static boolean debug = false;
	
	public void mousePressed(MouseEvent arg0) {		
		super.mousePressed(arg0);
		int x = arg0.getX();
		int y = canvas.getHeight() - arg0.getY() - 1;
		drawnLocation[0] = x;
		drawnLocation[1] = y;
//		System.out.println(x + ", " + y);
		//System.out.println(arg0.getX() + ", " + arg0.getY());
		//chooseStructure(arg0.getX(), canvas.getHeight() - arg0.getY() - 1);
		if(x >= 0 && x < images[0].width && y >= 0 && y < images[0].height){
			//images[images.length - 1] = images[0].directionY.getRegion(x, y, images[0].principleDirections);
			//images[images.length - 1] = Image.getRegion2(x, y, images[1], images[0].principleDirections);
			/*
			debug = true;
			List pixels = Image.getRegion3(x, y, new Image(thinnedCurvatureBin), images[0].principleDirections);
			images[images.length - 1].scale(0);
			images[images.length - 1].addPixels(pixels);
			images[images.length - 1].createDrawnImage();
			*/
			//images[images.length - 1] = Image.removeWrinkles(images[2], images[1], images[0].principleDirections);
			//imageIndex = images.length - 1;

			/*
			wrinkles = Image.removeWrinkles(threshCurvatureBin, thinnedCurvatureBin, sourceImage, sourceImage.principleDirections, sourceImage.normalDirections);
			images[images.length - 2].applyWrinkles(wrinkles);
			images[images.length - 1] = new Image(sourceImage);
			images[images.length - 1].subtract(images[images.length - 2]);
			*/
			
		}
		canvas.repaint();
	}

	public void mouseMoved(MouseEvent arg0) {		
		super.mouseMoved(arg0);
		int x = arg0.getX();
		int y = canvas.getHeight() - arg0.getY() - 1;
		
		float closestDist = Float.POSITIVE_INFINITY;
		
		drawnLocation[0] = x;
		drawnLocation[1] = y;
		if(wrinkles != null){
			for(int i = 0; i < wrinkles.size(); i++){
				Wrinkle wrinkle = (Wrinkle)wrinkles.get(i);
				for(int j = 0; j < wrinkle.pixels.size(); j++){
					Pixel pixel = (Pixel)wrinkle.pixels.get(j);
					float dist = (pixel.x - x) * (pixel.x - x) + (pixel.y - y) * (pixel.y - y);  
					if(dist < closestDist){
						selectedWrinkle = wrinkle;
						closestDist = dist;
						//System.out.println("found wrinkle");
					}
				}
			}
			//System.out.println("no wrinkle");
		}		
		//System.out.println(x + ", " + y);
		//System.out.println(arg0.getX() + ", " + arg0.getY());
		//chooseStructure(arg0.getX(), canvas.getHeight() - arg0.getY() - 1);
		canvas.repaint();
	}
}
