/*
 * Created on Jun 17, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;
import java.awt.*;
import java.awt.event.*; 
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;
import java.util.List;

import javax.vecmath.Point3d;
import javax.vecmath.Vector2d;
import javax.vecmath.Vector2f;
import javax.vecmath.Vector3d;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLU;
import net.java.games.jogl.util.GLUT;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Loader extends ArcBall implements KeyListener, MouseListener{
	int chosenMarker = -1;
	boolean drawNormals = false;
	boolean drawBase = false;
	boolean drawBoundary = false;
	int drawPlaneProjection = 0;
	
	final static int NO_PLANE_PROJECTION = 0;
	final static int GL_PLANE_PROJECTION = 1;
	final static int MANUAL_PLANE_PROJECTION = 2;
	
	List meshes = new ArrayList();
	boolean showIrregular = false;
	
	int meshIndex = 0;;
	Mesh mesh;
	static int GEOMETRY_NORMALS = 0;
	static int OBJ_NORMALS = 1;
	static int TEXTURE_NORMALS = 2;
	static int NO_NORMALS = 3;
	
	static int NO_COLOR = 0;
	static int TEXTURE_COLOR = 1;
	static int NORMAL_COLOR = 2;	
	static int UV_COLOR = 3;
	
	int normalMode = GEOMETRY_NORMALS;
	int colorMode = NO_COLOR;
	
	boolean renderPoints = true;
	boolean renderLines = false;
	
	String detailFile;
	
	public Loader(String files[]){
		for(int i = 0; i < files.length; i++){
			File file = new File(files[i]);
			if(file.isDirectory()){
				File subFiles[] = file.listFiles();
				for(int j = 0; j < Math.min(subFiles.length, 4); j++)
					meshes.add(new Mesh(subFiles[j].getAbsolutePath()));
			}
			else{
				meshes.add(new Mesh(files[i]));
			}
		}
		init();
	}		

	public Loader(Mesh inputMeshes[]){
		for(int i = 0; i < inputMeshes.length; i++)
			meshes.add(inputMeshes[i]);
		init();
	}		

	
	private void init(){
		mesh = (Mesh)meshes.get(meshIndex);
		markerQueue = new ArrayList();
		markerMoveQueue = new ArrayList();
		canvas.addKeyListener(this);		
	}
	
	Vector3d defaultNormal = new Vector3d(1, 0, 0);
	
	Vector3d getNormal(Vertex v, Face f){
		if(normalMode == GEOMETRY_NORMALS){
			if(f == null)
				return v.objNormal;
			else return f.normal; 
		}
		else if(normalMode == OBJ_NORMALS){
			return v.objNormal;
		}
		else if(normalMode == TEXTURE_NORMALS){        			        		
    		return v.photoNormal;
    	}
		else if(normalMode == NO_NORMALS){        			        		
    		return defaultNormal;
    	}
		return null;
	}
	
	Vector3d defaultColor = new Vector3d(.5, .5, .5);
	
	Vector3d getColor(Vertex v){
		if(colorMode == NO_COLOR)
			return defaultColor; 
		else if(colorMode == TEXTURE_COLOR){	        		
    		return v.color;
		}
		else if(colorMode == NORMAL_COLOR){
			return v.photoNormal;
		}
		else if(colorMode == UV_COLOR){
			return v.uvColor;
		}
		return null;	
	}
	
	List markerQueue;
	List markerMoveQueue;
	
	Vertex closestVertexToClick(List vertices, Vector2d clickPos, GL gl, GLU glu){
    	double[] modelMatrix = new double[16];
    	gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX, modelMatrix);
    	double[] projectionMatrix = new double[16];
    	gl.glGetDoublev(GL.GL_PROJECTION_MATRIX, projectionMatrix);
    	int[] viewport = new int[4];
    	gl.glGetIntegerv(GL.GL_VIEWPORT, viewport);
    	double[] objX = new double[1], objY = new double[1], objZ = new double[1];

    	glu.gluUnProject(clickPos.x, clickPos.y, 0, modelMatrix, projectionMatrix, viewport, objX, objY, objZ);
    	Vector3d front = new Vector3d(objX[0], objY[0], objZ[0]);
    	glu.gluUnProject(clickPos.x, clickPos.y, 1, modelMatrix, projectionMatrix, viewport, objX, objY, objZ);
    	Vector3d back = new Vector3d(objX[0], objY[0], objZ[0]);

    	Vertex closestVertex = Mesh.closestVertexToLine(vertices, front, back);
    	return closestVertex;
	}
	
	void processMarkerQueue(GL gl, GLU glu, GLUT glut){
    	double[] modelMatrix = new double[16];
    	gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX, modelMatrix);
    	double[] projectionMatrix = new double[16];
    	gl.glGetDoublev(GL.GL_PROJECTION_MATRIX, projectionMatrix);
    	int[] viewport = new int[4];
    	gl.glGetIntegerv(GL.GL_VIEWPORT, viewport);
    	double[] objX = new double[1], objY = new double[1], objZ = new double[1];
    	for(int i = 0; i < markerQueue.size(); i++){
    		
    		Vector2d clickPos = (Vector2d)markerQueue.get(i);
    		/*
    		System.out.println("Placing marker " + mesh.markers.size() + ", clicked at: " + clickPos);
	    	glu.gluUnProject(clickPos.x, clickPos.y, 0, modelMatrix, projectionMatrix, viewport, objX, objY, objZ);
	    	Vector3d front = new Vector3d(objX[0], objY[0], objZ[0]);
	    	glu.gluUnProject(clickPos.x, clickPos.y, 1, modelMatrix, projectionMatrix, viewport, objX, objY, objZ);
	    	Vector3d back = new Vector3d(objX[0], objY[0], objZ[0]);
	    	*/
    		
	    	/*
	    	Vector3d dir = new Vector3d();
	    	dir.sub(back, front);
	    	dir.normalize();
    		Vector3d diff = new Vector3d();
	    	double minDist = Double.POSITIVE_INFINITY;
    		Vertex closestVertex = null;
	    	for(int j = 0; j < mesh.vertices.size(); j++){
	    		Vertex v = (Vertex)mesh.vertices.get(j);
	    		diff.sub(front, v.pos);
	    		diff.cross(diff, dir);
	    		double distSquared = diff.lengthSquared();
	    		if(distSquared < minDist){
	    			minDist = distSquared;
	    			closestVertex = v;
	    		}
	    	}
	    	System.out.println("   Closest vertex: " + closestVertex.index + ", " + closestVertex.pos);
	    	*/
	    	
    		//Vertex closestVertex = mesh.closestVertexToLine(front, back);
    		Vertex closestVertex = closestVertexToClick(mesh.vertices, clickPos, gl, glu);
	    	mesh.markers.add(closestVertex);
    	}
    	markerQueue.clear();		
	}
	
	void processMarkerMoveQueue(GL gl, GLU glu, GLUT glut){
    	for(int i = 0; i < markerMoveQueue.size(); i++){    		
    		Vector2d clickPos = (Vector2d)markerMoveQueue.get(i);
    		Vertex closestMarkerVertex = closestVertexToClick(mesh.markers, clickPos, gl, glu);    		    		
    		Vertex closestMeshVertex = closestVertexToClick(mesh.vertices, clickPos, gl, glu);
    		//closestMarkerVertex.pos.set(closestMeshVertex.pos);
	    	mesh.markers.set(mesh.markers.indexOf(closestMarkerVertex), closestMeshVertex);
    	}
    	markerMoveQueue.clear();		
	}

	
	boolean saveImage = false;
	
	static int imageSize = 1024;
	
	Image image;
	Raster raster;
	
	public void saveImage(/*GL gl, double min, double max, double[] details*/){
		int periodPosition = mesh.meshFile.lastIndexOf('.');
		if(periodPosition < 0)
			periodPosition = mesh.meshFile.length();
		String imageFile = mesh.meshFile.substring(0, periodPosition) + ".img";
		/*
		int width = canvas.getWidth();
    	int height = canvas.getHeight();
    	
    	float pixels[] = new float[width * height];
    	gl.glReadPixels(0, 0, width, height, GL.GL_RED, GL.GL_FLOAT, pixels);
    	*/
		
		/*
		int width = image.width;
		int height = image.height;
    	float pixels[] = image.drawnImage;
    	
    	    	
    	saveImage = false;
    	for(int k = 1000; k < 1025 ; k++){
    		Vertex imageVertex = (Vertex)mesh.imageMesh.vertices.get(k);
    		Vector3d pos3d = imageVertex.pos;
			Vector2f pos = new Vector2f((float)pos3d.x, (float)pos3d.y);
			int x = Math.round(pos.x);
			int y = Math.round(pos.y);
			//if(x == width) x = width - 1;
			//if(y == height) y = height - 1;
			System.out.println(image.data[x][y] + ", " + image.data(pos.x, pos.y) + ": " +  details[k] + " | " + raster.hits[x][y] + 
						" (" + pos.x + ", " + pos.y + ") [" + x + ", " + y + "]");
    	}
    	*/
		if(image == null)
			System.out.println("Image not created yet!");
		else
			image.save(imageFile);
    	/*
		FileOutputStream fstream = new FileOutputStream(imageFile, false);
		BufferedOutputStream bstream = new BufferedOutputStream(fstream, width * height * 4);
		DataOutputStream dstream = new DataOutputStream(bstream);				
		dstream.writeInt(width);
		dstream.writeInt(height);
		float minDetail = Float.POSITIVE_INFINITY;
		for(int i = 0; i < pixels.length; i++){
			float detail = (float)(pixels[i] * (max - min) + min);
			dstream.writeFloat(detail);
			if(detail < minDetail)
				minDetail = detail;
		}
						
		dstream.close();
		System.out.println(minDetail);
		System.out.println("Saved " + width + "x" + height + " image to: " + imageFile + " min/max: " + min + "/" + max);
		*/		
	}
	
    public void draw(GL gl, GLU glu, GLUT glut)
    {    	    	
    	try{
    		//canvas.setSize(256, 256);
    		//System.out.println(canvas.getSize());


	    	if(!markerQueue.isEmpty()){
	    		processMarkerQueue(gl, glu, glut);
	    	}
	    	if(!markerMoveQueue.isEmpty())
	    		processMarkerMoveQueue(gl, glu, glut);
	    	
	    	
	    	gl.glPointSize(1.5f);
	    	if(renderLines)
	    		gl.glPolygonMode(GL.GL_FRONT, GL.GL_LINE);
	    	else
	    		gl.glPolygonMode(GL.GL_FRONT, GL.GL_FILL);
	    	gl.glClear (GL.GL_COLOR_BUFFER_BIT);
	        gl.glClear (GL.GL_DEPTH_BUFFER_BIT);
	        gl.glColor3f( 1.0f, 0.0f, 0.0f ); 
	        //System.out.println("here");
	        //glut.glutSolidCube(gl, 6);
	        gl.glColor3f(0, 1, 0);
	        if(normalMode == NO_NORMALS)
	            gl.glDisable(GL.GL_LIGHTING);
	        else
	            gl.glEnable(GL.GL_LIGHTING);        	
	        /*
	        gl.glVertex3d(0, 0, 0);
	        gl.glVertex3d(1, 0, 0);        
	        gl.glVertex3d(1, 1, 0);
	        */
	        if(drawPlaneProjection == MANUAL_PLANE_PROJECTION){
	    		if(raster == null){
	    			System.out.println("Rasterizing displacements as " + imageSize + " image");
	    			double[] details = null;
		    		int detailSource = meshIndex;
		    		if(Mesh.details != null && Mesh.details.length > 0){
		    			for(int i = 0; i < Mesh.details[detailSource].length; i++)
		    				if(Mesh.details[detailSource][i].length == mesh.vertices.size())
		    					details = Mesh.details[detailSource][i];
		    			
		    		}
		    		double minDetail = Double.POSITIVE_INFINITY;
		    		double maxDetail = Double.NEGATIVE_INFINITY;
					if(details != null){
		    			for(int i = 0; i < details.length; i++){
		        			double detail = details[i];
		        			if(detail > maxDetail) maxDetail = detail;
		        			if(detail < minDetail) minDetail = detail;
		        		}
					}
					raster = new Raster(imageSize, imageSize, /*mesh,*/ details);
					image = raster.getImage();
				}
				image.drawImage(gl);
	        	/*
				if(saveImage){
	        		saveImage(gl, minDetail, maxDetail, details);
	        	}
	        	*/
	        }
	        /*
	        else if(drawPlaneProjection == GL_PLANE_PROJECTION){
	    		double[] details = null;
	    		int detailSource = meshIndex;
	    		if(Mesh.details != null && Mesh.details.length > 0){
	    			for(int i = 0; i < Mesh.details[detailSource].length; i++)
	    				if(Mesh.details[detailSource][i].length == mesh.vertices.size())
	    					details = Mesh.details[detailSource][i];
	    			
	    		}
	    		double minDetail = Double.POSITIVE_INFINITY;
	    		double maxDetail = Double.NEGATIVE_INFINITY;
				if(details != null){
	    			for(int i = 0; i < details.length; i++){
	        			double detail = details[i];
	        			if(detail > maxDetail) maxDetail = detail;
	        			if(detail < minDetail) minDetail = detail;
	        		}
				}
	    		//System.out.println(maxDetail);
	        	
				gl.glMatrixMode( GL.GL_PROJECTION );  
	            gl.glPushMatrix();
	            gl.glLoadIdentity(); 
	            //glu.gluOrtho2D( 0.0, 450.0, 0.0, 375.0);
	            //double imageSize = 1;
	            gl.glOrtho(0, imageSize, 0, imageSize, -30, 30);    
	            gl.glMatrixMode(GL.GL_MODELVIEW);
	        	gl.glPushMatrix();
	        	gl.glLoadIdentity();
	            
	        	
        		double[] window_x = new double[1], window_y = new double[1], window_z = new double[1];
        		double[] modelViewMatrix = new double[16];
        		double[] projectionMatrix = new double[16];
        		int[] viewport = new int[4]; 
        		gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX, modelViewMatrix);
        		gl.glGetDoublev(GL.GL_PROJECTION_MATRIX, projectionMatrix);
        		gl.glGetIntegerv(GL.GL_VIEWPORT, viewport);
	        	
	        	gl.glDisable(GL.GL_LIGHTING);        	
	        	gl.glBegin(GL.GL_TRIANGLES);
	        	
	        	//System.out.println(mesh.vertices.size() + ": " + mesh.imageMesh.vertices.size());
	        	for(int i = 0; i < mesh.faces.size(); i++){
		        	Face f = (Face)mesh.faces.get(i);
		        	for(int j = 0; j < f.vertices.length; j++){
		        		Vertex v = (Vertex)mesh.vertices.get(f.vertices[j]);
		        		Vertex imageVertex = (Vertex)mesh.imageMesh.vertices.get(f.vertices[j]);
		        		//System.out.println(v.index + ": " + v.textureCoords);	        		
		        		
		        		
		        		if(details != null){
		        			double displacement = (details[v.index] - minDetail) / (maxDetail - minDetail);
		        			gl.glColor3d(displacement, displacement, displacement);
		        		}
		        		else
		        			gl.glColor3d(v.objNormal.x, v.objNormal.y, v.objNormal.z);
		        		
		        		
	        			//gl.glColor3d(v.objNormal.x, v.objNormal.y, v.objNormal.z);
		        		
		        		//gl.glVertex3d(v.textureCoords.x, v.textureCoords.y, 0);
		        		gl.glVertex3d(imageVertex.pos.x, imageVertex.pos.y, imageVertex.pos.z);
		        		
		        		
		        		glu.gluProject(imageVertex.pos.x, imageVertex.pos.y, imageVertex.pos.z, 
		        				modelViewMatrix, projectionMatrix, viewport,
								window_x, window_y, window_z);

		        		Vector3d pos3d = imageVertex.pos;
		        		Vector2f pos = new Vector2f((float)pos3d.x, (float)pos3d.y);
		        		pos.x = (pos.x + 1) / 2 * (512);
		        		pos.y = (pos.y + 1) / 2 * (512);
						
		        		//System.out.println(window_x[0] + " " + window_y[0] + "; " + pos.x + " " + pos.y);
		        	}        
		        }	        
		        gl.glEnd();
		        
		        gl.glMatrixMode(GL.GL_PROJECTION);
		        gl.glPopMatrix();
		        gl.glMatrixMode(GL.GL_MODELVIEW);
	        	gl.glPopMatrix();        		        	
	        }
    		*/
	        else if(renderPoints){
		        gl.glBegin(GL.GL_POINTS);
		        for(int i = 0; i < mesh.vertices.size(); i++){
		        	Vertex v = (Vertex)mesh.vertices.get(i);
	        		Vector3d normal = getNormal(v, null);
	        		gl.glNormal3d(normal.x, normal.y, normal.z);
	
	        		Vector3d color = getColor(v);
	        		gl.glColor3d(color.x, color.y, color.z);
	        		gl.glVertex3d(v.pos.x, v.pos.y, v.pos.z);	        	        
		        }
		        gl.glEnd();
	        }
	        else{
		        gl.glBegin(GL.GL_TRIANGLES);
		        for(int i = 0; i < mesh.faces.size(); i++){
		        	Face f = (Face)mesh.faces.get(i);
		        	for(int j = 0; j < f.vertices.length; j++){
		        		Vertex v = (Vertex)mesh.vertices.get(f.vertices[j]);
		        		Vector3d normal = getNormal(v, f);
		        		gl.glNormal3d(normal.x, normal.y, normal.z);
		        		
		        		Vector3d color = getColor(v);
		        		gl.glColor3d(color.x, color.y, color.z);
		        		
		        		gl.glVertex3d(v.pos.x, v.pos.y, v.pos.z);          		        		
		        	}        
		        }
		        
		        gl.glEnd();
	        }
	        
	    	gl.glPointSize(10);
			gl.glColor3d(1, 0, 0);
	    	for(int i = 0; i < mesh.markers.size(); i++){
	    		Vertex v = (Vertex)mesh.markers.get(i);    		
	    		gl.glPushMatrix();
	    		gl.glTranslated(v.pos.x, v.pos.y, v.pos.z);
	    		glut.glutSolidSphere(glu, .005 * camWidth, 16, 16);
	    		gl.glDisable(GL.GL_DEPTH_TEST);
	    		gl.glRasterPos3d(0, 0, 0);
	    		String indStr = Integer.toString(i);
	    		for(int j = 0; j < indStr.length(); j++)
	    			glut.glutBitmapCharacter(gl, GLUT.BITMAP_HELVETICA_18, indStr.charAt(j));
	    		gl.glEnable(GL.GL_DEPTH_TEST);
	    		gl.glPopMatrix();
	    	}
	    	
	    	if(showIrregular || drawBoundary || drawBase){
	    		boolean draw;
	    		for(int i = 0; i < mesh.vertices.size(); i++){
		    		draw = false;
	    			Vertex v = (Vertex)mesh.vertices.get(i);    		
		    		if(showIrregular && v.neighbors.size() != 6){
		    			draw = true;
		        		gl.glColor3d(1, 0, 0);
		    		}
		    		else if(drawBoundary && v.boundary){
		    			draw = true;
		        		gl.glColor3d(0, 0, 1);	    			
		    		}
		    		else if(drawBase && v.baseVertex){
		    			draw = true;
		        		gl.glColor3d(0, 1, 0);	    			
		    		}
	    			
		    		if(draw){
			    		gl.glPushMatrix();
			    		gl.glTranslated(v.pos.x, v.pos.y, v.pos.z);	    		
			    		glut.glutSolidSphere(glu, .004 * camWidth, 20, 20);
			    		gl.glPopMatrix();    				
		    		}
	    		}    		
	    	}
	    	/*
	    	if(showIrregular){
	    		gl.glColor3d(1, 0, 0);
	    		for(int i = 0; i < mesh.vertices.size(); i++){
	    			if(((List)mesh.vertex2neighbors.get(i)).size() != 6){
	    	    		Vertex v = (Vertex)mesh.vertices.get(i);    		
	    	    		gl.glPushMatrix();
	    	    		gl.glTranslated(v.pos.x, v.pos.y, v.pos.z);
	    	    		glut.glutSolidSphere(glu, .004 * camWidth, 20, 20);
	    	    		gl.glPopMatrix();    				
	    			}
	    		}
	    	}
	
	    	if(drawBoundary){
	    		gl.glColor3d(0, 0, 1);
	    		for(int i = 0; i < mesh.vertices.size(); i++){
		    		Vertex v = (Vertex)mesh.vertices.get(i);
		    		if(v.boundary){
	    	    		gl.glPushMatrix();
	    	    		gl.glTranslated(v.pos.x, v.pos.y, v.pos.z);
	    	    		glut.glutSolidSphere(glu, .004 * camWidth, 20, 20);
	    	    		gl.glPopMatrix();
		    		}
	    		}
	    	}
	    	*/
	    	
			gl.glColor3d(0, 1, 0);
			for(int i = 0; i < mesh.vertices.size(); i++){
	    		Vertex v = (Vertex)mesh.vertices.get(i);    		
	    		if(v.bright){
	    			gl.glPushMatrix();
	    			gl.glTranslated(v.pos.x, v.pos.y, v.pos.z);
		    		glut.glutSolidSphere(glu, .003 * camWidth, 6, 6);
		    		gl.glPopMatrix();    				
				}
			}
			
			if(drawNormals){
				gl.glDisable(GL.GL_LIGHTING);
				gl.glBegin(GL.GL_LINES);
				gl.glColor3d(1, 0, 0);
				double normalSize = .02;
				for(int i = 0; i < mesh.vertices.size(); i++){
		    		Vertex v = (Vertex)mesh.vertices.get(i);    		
					Vector3d normal = v.objNormal;
		    		if(normal != null){
		    			gl.glVertex3d(v.pos.x, v.pos.y, v.pos.z);
		    			gl.glVertex3d(v.pos.x + normal.x * normalSize, v.pos.y + normal.y * normalSize, v.pos.z + normal.z * normalSize);
		    		}
				}
				gl.glEnd();
			}
    	}
    	catch(Exception e){
    		e.printStackTrace();
    	}    	
    }	
    
	public static void main(String[] args) {		
		
		Loader loader = new Loader(args);
		loader.pack();
		loader.setVisible(true);
		
		/*
		Vector3d intersect = Correspondence.triangleRayIntersect(new Vector3d(0, 0, 0), new Vector3d(1, 0, 0), new Vector3d(0, 1, 0), 
				new Point3d(0, 0, 1), new Vector3d(1, 0, -1));
		
		System.out.println(intersect);
		*/
	}
	
	public static void projectMeshOnMesh(Mesh from, Mesh to, String detailFile){
		double details[] = (from).projectOn(to);
		if(detailFile != null){
			try{
				System.out.println("  writing details to " + detailFile);						
				FileOutputStream fstream = new FileOutputStream(detailFile, true);
				BufferedOutputStream bstream = new BufferedOutputStream(fstream, details.length * 2 + 1);
				DataOutputStream dstream = new DataOutputStream(bstream);				
				dstream.writeInt(details.length);
				for(int i = 0; i < details.length; i++){
					dstream.writeDouble(details[i]);
				}
				dstream.writeInt(from.detailLevel);
				System.out.println("  detail level: " + from.detailLevel);
				dstream.close();
				from.detailLevel++;
			}
			catch(IOException e){
				System.out.println(e);
			}					
		}		
	}

	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
	 */
	public void keyPressed(KeyEvent arg0) {
		if(arg0.isControlDown()){
			if(arg0.getKeyCode() == KeyEvent.VK_S){
				FileDialog fd = new FileDialog(this, "Save as", FileDialog.SAVE);
				fd.setFile(mesh.meshFile);
				fd.show();				
				String fileName = fd.getDirectory() + fd.getFile();
				if(fileName == null)
					return;
				System.out.println("Selected file: " + fileName);
				mesh.saveAs(fileName);
			}
			else if(arg0.getKeyCode() == KeyEvent.VK_M){
				int periodPosition = mesh.meshFile.lastIndexOf('.');
				if(periodPosition < 0)
					periodPosition = mesh.meshFile.length();
				String markerFile = mesh.meshFile.substring(0, periodPosition) + ".mkr";

				String fileName = null;
				if(arg0.isShiftDown()){
					fileName = BatchUtil.markersDir + (new File(markerFile)).getName(); 
				}
				else{					
					FileDialog fd = new FileDialog(this, "Load marker", FileDialog.LOAD);
					fd.setFile(markerFile);
					fd.show();				
					fileName = fd.getDirectory() + fd.getFile();
				}
				if(fileName == null)
					return;
				System.out.println("Loading markers from " + fileName);
				mesh.loadMarkers(fileName);				
			}
			else if(arg0.getKeyCode() == KeyEvent.VK_D){
				int periodPosition = mesh.meshFile.lastIndexOf('.');
				if(periodPosition < 0)
					periodPosition = mesh.meshFile.length();
				detailFile = mesh.meshFile.substring(0, periodPosition) + ".det";

				FileDialog fd = new FileDialog(this, "Load details", FileDialog.LOAD);
				fd.setFile(detailFile);
				fd.show();				
				if(fd.getFile() == null)
					return;
				detailFile = fd.getDirectory() + fd.getFile();
				System.out.println("Reading details from: " + detailFile);
				Mesh.readDetails(detailFile);
			}
		}
		else{
			if(arg0.getKeyChar() == 'x'){
				normalMode = (normalMode + 1) % 4;
				System.out.println("Normal mode: " + normalMode);
			}
			else if(arg0.getKeyChar() == 'z'){
				normalMode = (normalMode + 3) % 4;
				System.out.println("Normal mode: " + normalMode);
			}
			else if(arg0.getKeyChar() == 'v'){
				colorMode = (colorMode + 1)%4;
				System.out.println("Color mode: " + colorMode);
			}
			else if(arg0.getKeyChar() == 'c'){
				colorMode = (colorMode + 3)%4;
				System.out.println("Color mode: " + colorMode);
			}
			else if(arg0.getKeyChar() == ' '){
				renderPoints = !renderPoints;
				System.out.println("Render points: " + renderPoints);
			}
			else if(arg0.getKeyChar() == 'N'){
				drawNormals = !drawNormals;
				System.out.println("Draw normals: " + drawNormals);
			}
			else if(arg0.getKeyChar() == 'B'){
				drawBoundary = !drawBoundary;
				System.out.println("Draw boundary: " + drawBoundary);
			}
			else if(arg0.getKeyChar() == 'M'){
				drawBase = !drawBase;
				System.out.println("Draw base: " + drawBase);
			}
			else if(arg0.getKeyChar() == 'l'){
				renderLines = !renderLines;
				System.out.println("Render lines: " + renderLines);
			}
			else if(arg0.getKeyChar() == 'i'){
				showIrregular = !showIrregular;
				System.out.println("Draw irregular vertices: " + showIrregular);
			}
			else if(arg0.getKeyChar() == 'I'){
				saveImage();
			}
			else if(arg0.getKeyChar() == '>' || arg0.getKeyChar() == '.'){
				meshIndex = (meshIndex + 1) % meshes.size();
				mesh = (Mesh)meshes.get(meshIndex);				
				System.out.println("Switched to mesh " + meshIndex + ": " + mesh.meshFile);
			}
			else if(arg0.getKeyChar() == '<' || arg0.getKeyChar() == ','){
				meshIndex = (meshIndex + meshes.size() - 1) % meshes.size();
				mesh = (Mesh)meshes.get(meshIndex);				
				System.out.println("Switched to mesh " + meshIndex + ": " + mesh.meshFile);
			}
			else if(arg0.getKeyChar() == 's'){
				System.out.println("Smoothing..");
				mesh.smooth();
			}
			else if(arg0.getKeyChar() == 'C'){
				System.out.println("Saving connectivity");
				mesh.saveConnectivity(BatchUtil.connectivityFile);
				/*
				System.out.println("Coarsening..");
				mesh.coarsen();
				System.out.println("Done coarsening");
				*/
				/*
				Mesh newMesh = new Mesh(mesh);
				meshes.add(meshIndex, newMesh);
				mesh = newMesh;
				*/
			}
			else if(arg0.getKeyChar() == 'w'){
				System.out.println("Warping..");
				Correspondence.warp((Mesh)meshes.get(0), ((Mesh)meshes.get(1)).markers);
			}
			else if(arg0.getKeyChar() == 'o'){
				/*
				System.out.println("Finding proj direction..");
				Correspondence.findProjectionDir((Mesh)meshes.get(0), (Mesh)meshes.get(1));
				*/
				int periodPosition = mesh.meshFile.lastIndexOf('.');
				if(periodPosition < 0)
					periodPosition = mesh.meshFile.length();
				String imageFile = mesh.meshFile.substring(0, periodPosition) + ".img";

				FileDialog fd = new FileDialog(this, "Load image", FileDialog.LOAD);
				fd.setFile(imageFile);
				fd.show();				
				if(fd.getFile() == null)
					return;
				imageFile = fd.getDirectory() + fd.getFile();
				mesh.applyImageDetail(imageFile);
			}
			else if(arg0.getKeyChar() == 'p'){
				drawPlaneProjection = (drawPlaneProjection + 1) % 3;
				/*
				System.out.println("Doing initial projection");
				Correspondence.project((Mesh)meshes.get(0), (Mesh)meshes.get(1));
				*/
			}
			else if(arg0.getKeyChar() == 'A'){
				System.out.println("Augmenting markers w/ base");
				mesh.augmentMarkersWithBase();				
			}
			else if(arg0.getKeyChar() == 'P'){
				System.out.println("Projecting in normal direction");
				projectMeshOnMesh((Mesh)meshes.get(0), (Mesh)meshes.get(1), detailFile);
				//((Mesh)meshes.get(0)).projectToClosestVertex((Mesh)meshes.get(1));
				/*
				double details[] = ((Mesh)meshes.get(0)).projectOn((Mesh)meshes.get(1));
				if(detailFile != null){
					try{
						System.out.println("  writing details to " + detailFile);						
						FileOutputStream fstream = new FileOutputStream(detailFile, true);
						BufferedOutputStream bstream = new BufferedOutputStream(fstream, details.length * 2 + 1);
						DataOutputStream dstream = new DataOutputStream(bstream);				
						dstream.writeInt(details.length);
						for(int i = 0; i < details.length; i++){
							dstream.writeDouble(details[i]);
						}
						dstream.writeInt(mesh.detailLevel);
						System.out.println("  detail level: " + mesh.detailLevel);
						dstream.close();
						mesh.detailLevel++;
					}
					catch(IOException e){
						System.out.println(e);
					}					
				}
				*/
			}
			else if(arg0.getKeyChar() == 'r'){
				System.out.println("Refining mesh");
				System.out.println("  old mesh: " + mesh);
				mesh.subdivide(Mesh.LINEAR_SUBDIVISION);
				System.out.println("  new mesh: " + mesh);
				System.out.println("  done");				
			}
			else if(arg0.getKeyChar() == 't'){
				System.out.println("Refining mesh with Loop subdivision");
				System.out.println("  old mesh: " + mesh);
				mesh.subdivide(Mesh.LOOP_SUBDIVISION);
				System.out.println("  new mesh: " + mesh);
				System.out.println("  done");				
			}
			else if(arg0.getKeyChar() == 'y'){
				System.out.println("Refining mesh with Butterfly subdivision");
				System.out.println("  old mesh: " + mesh);
				mesh.subdivide(Mesh.BUTTERFLY_SUBDIVISION);
				System.out.println("  new mesh: " + mesh);
				System.out.println("  done");				
			}
			else if(arg0.getKeyChar() == 'e'){
				System.out.println("Relaxing...");
				mesh.relax();
			}
			else if(arg0.getKeyChar() == 'E'){
				System.out.println("Relaxing...");
				mesh.convegeMarkers(((Mesh)meshes.get(1)).markers);
			}
			else if(arg0.getKeyChar() == '['){
				chosenMarker = (chosenMarker - 1) % (mesh.markers.size() + 1) - 1;
				System.out.println("New chosen marker: " + chosenMarker);
			}
			else if(arg0.getKeyChar() == ']'){
				chosenMarker = (chosenMarker + 1) % (mesh.markers.size() + 1) - 1;
				System.out.println("New chosen marker: " + chosenMarker);
			}
			else if(arg0.getKeyChar() == 'b'){
				System.out.println("Extracting base mesh from markers");
				meshes.add(meshIndex, mesh.baseMesh());
				mesh = (Mesh)meshes.get(meshIndex);
			}
			else if(arg0.getKeyChar() == 'R'){
				System.out.println("Creating rectangle...");
				double minX = Double.POSITIVE_INFINITY, minY = Double.POSITIVE_INFINITY;
				double maxX = Double.NEGATIVE_INFINITY, maxY = Double.NEGATIVE_INFINITY;  
				double maxZ = Double.NEGATIVE_INFINITY;
				for(int i = 0; i < mesh.vertices.size(); i++){
					Vertex v = (Vertex)mesh.vertices.get(i);
					if(v.pos.x < minX) minX = v.pos.x;
					if(v.pos.y < minY) minY = v.pos.y;
					if(v.pos.x > maxX) maxX = v.pos.x;
					if(v.pos.y > maxY) maxY = v.pos.y;
					if(v.pos.z > maxZ) maxZ = v.pos.z;
				}
				double centerX = .5 * (minX + maxX);
				double centerY = .5 * (minY + maxY);
				double scale = Math.max(maxX - minX, maxY - minY);
				System.out.println("Center: (" + centerX + ", " + centerY + "); scale: " + scale);
				
				
				Mesh rect = Mesh.rectangle(5, centerX, centerY, maxZ, scale);
				meshes.add(meshIndex, rect);
				mesh = (Mesh)meshes.get(meshIndex);
										
			}
			else if(arg0.getKeyChar() == 'd'){
				int periodPosition = mesh.meshFile.lastIndexOf('.');
				if(periodPosition < 0)
					periodPosition = mesh.meshFile.length();
				detailFile = mesh.meshFile.substring(0, periodPosition) + ".det";

				FileDialog fd = new FileDialog(this, "Save details as", FileDialog.SAVE);
				fd.setFile(detailFile);
				fd.show();				
				if(fd.getFile() == null)
					return;
				detailFile = fd.getDirectory() + fd.getFile();
				try{
					FileOutputStream fstream = new FileOutputStream(detailFile);
					fstream.close();
				}
				catch(IOException e){
					e.printStackTrace();
				}
				
				System.out.println("Detail output file set to: " + detailFile);
			}						
			else if(arg0.getKeyChar() == 'm'){
				int periodPosition = mesh.meshFile.lastIndexOf('.');
				if(periodPosition < 0)
					periodPosition = mesh.meshFile.length();
				String markerFile = mesh.meshFile.substring(0, periodPosition) + ".mkr";
				markerFile = (new File(markerFile)).getName();
				
				FileDialog fd = new FileDialog(this, "Save markers as", FileDialog.SAVE);
				fd.setFile(markerFile);
				fd.show();				
				markerFile = fd.getDirectory() + fd.getFile();
				if(markerFile == null)
					return;
				//System.out.println("Selected file: " + markerFile);
				
				
				try{
					FileWriter writer = new FileWriter(markerFile);
					writer.write(mesh.markers.size() + "\n");
					for(int i = 0; i < mesh.markers.size(); i++){
						Vertex v = (Vertex)mesh.markers.get(i);
						//int vertexIndex = mesh.vertices.indexOf(v);
						int vertexIndex = mesh.closestVertexTo(v);
						if(vertexIndex < 0 || vertexIndex >= mesh.vertices.size())
							throw new RuntimeException();
						
						Face vFace = null;
						int faceIndex = -1;
						String barCoords = null;
						for(int j = 0; j < mesh.faces.size(); j++){
							Face f = (Face)mesh.faces.get(j);
							for(int k = 0; k < 3; k++){
								if(f.vertices[k] == vertexIndex){
									faceIndex = j;
									vFace = f;
									if(k == 0)
										barCoords = " 1 0 0";
									else if(k == 1)
										barCoords = " 0 1 0";
									else
										barCoords = " 0 0 1";
									break;
								}
							}
						}
						//writer.write(v.pos.x + " " + v.pos.y + " " + v.pos.z + " 0 0 0 0\n");
					    //OTHER LINES are of format X Y Z Iv It It0 It1 It2 w0 w1 w2 
						writer.write(v.pos.x + " " + v.pos.y + " " + v.pos.z + " " + vertexIndex + " " 
								+ faceIndex + " " + vFace.vertices[0] + " " + vFace.vertices[1] + " " + 
								vFace.vertices[2] + barCoords + "\n");						
					}
					
					writer.close();
					System.out.println("Markers saved to: " + markerFile);
				}
				catch(IOException e){
					System.out.println(e);
				}
			}
			else if(arg0.getKeyChar() == 'W'){
				int periodPosition = mesh.meshFile.lastIndexOf('.');
				if(periodPosition < 0)
					periodPosition = mesh.meshFile.length();
				String weightFile = mesh.meshFile.substring(0, periodPosition) + ".wht";

				FileDialog fd = new FileDialog(this, "Save markers as", FileDialog.SAVE);
				fd.setFile(weightFile);
				fd.show();				
				weightFile = fd.getDirectory() + fd.getFile();
				if(weightFile == null)
					return;
				//System.out.println("Selected file: " + markerFile);
				
				
				try{
					FileWriter writer = new FileWriter(weightFile);
					for(int i = 0; i < mesh.vertices.size(); i++){
						writer.write("1\n");
					}					
					writer.close();
					System.out.println("Weights saved to: " + weightFile);
				}
				catch(IOException e){
					System.out.println(e);
				}
			}
			else if(arg0.getKeyCode() == KeyEvent.VK_BACK_SPACE){
				mesh.markers.remove(mesh.markers.size() - 1);
				System.out.println("Erased marker: " + mesh.markers.size());
			}
			else if(Character.isDigit(arg0.getKeyChar())){
				Mesh detailedMesh = mesh.applyDetail(Character.getNumericValue(arg0.getKeyChar()));
				if(detailedMesh != mesh){
					meshes.add(meshIndex, detailedMesh);
					mesh = (Mesh)meshes.get(meshIndex);
				}
			}
			canvas.repaint();
		}
	}

	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
	 */
	public void keyReleased(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
	 */
	public void keyTyped(KeyEvent arg0) {	
	}

	public void mousePressed(MouseEvent arg0) {
		//System.out.println(arg0.getX() + " " + arg0.getY());
		if(arg0.getButton() == MouseEvent.BUTTON1 && arg0.isControlDown()){
			if(arg0.isShiftDown())
				markerMoveQueue.add(new Vector2d(arg0.getX(), canvas.getSize().height - arg0.getY() - 1));
			else
				markerQueue.add(new Vector2d(arg0.getX(), canvas.getSize().height - arg0.getY() - 1));
			canvas.repaint();
		}
		super.mousePressed(arg0);
	}
}
